*
* Sample for printing via Telepathy serial communication to a COM printer
*
* Telepaty is a trademark of Extrasensory Software
*
*---------------------------------------------------------------------------
STATIC nPort := 1
*---------------------------------------------------------------------------
FUNCTION Main()
LOCAL oPe
*
oPe := Pepageprint():New("HPLJIII","COM1")      && Create class
*
* define individual open/write/close codeblocks
*
oPe:OpenCodeBlock  := {| cDevice ,lCreate       | PeComOpen(cDevice,cCreate) }
oPe:WriteCodeBlock := {| nHandle ,cString ,nLen | PeComWrite(nHandle,cString,nLen)}
oPe:CloseCodeBlock := {| nHandle                | PeComClose(nHandle)}
*
* Printing goes here!
*
oPe:End()                                       && end printing
*
Return(NIL)
*---------------------------------------------------------------------------
FUNCTION PeComOpen(cDevice,lCreate)
LOCAL nRet := -1                                && Return value for error
*
* Translate string into numeric port
*
DO CASE
CASE cDevice == "COM1"
   nPort := 1
CASE cDevice == "COM2"
   nPort := 2
CASE cDevice == "COM3"
   nPort := 3
CASE cDevice == "COM4"
   nPort := 4
ENDCASE
*
IF Tp_isport(nPort)                             && if port is known, try to open
   *
   IF Tp_open(nPort,1536,1536,9600,8,"N",1) == 0
      nRet := 1                                 && Return any handle
   ENDIF
   *
ENDIF
Return(nRet)
*-------------------------------------------------------------------------------
FUNCTION PeComWrite(nHandle,cString,nLen)
*
Tp_send(nPort,cString,0)                        && send much as possible
*
IF Tp_error() == 0                              && No error
   Return(nLen)                                 && Return all written
ENDIF
Return(0)
*-------------------------------------------------------------------------------
FUNCTION PeComClose(nHandle)
*
Tp_flush(nPort,nTimeout)                        && Flush buffer
Tp_close(nPort,0)                               && close port
*
Return(.T.)
*-------------------------------------------------------------------------------
